
#include"maze.h"
#include"data.h"
//#include<math.h>

fixed dist(fixed x);
fixed div(fixed y,fixed x);
fixed divf(fixed y, fixed x);
///////////////DRAWMAZE////////////////////////
void drawmaze(int xview,
                 int yview,int viewing_angle,
                 int viewer_height)
// Draws a raycast image in the viewport of the maze represented
// in array MAP[], as seen from position XVIEW, YVIEW by a
// viewer looking at angle VIEWING_ANGLE where angle 0 is due
// north. (Angles are measured in radians.).  Works on 90 degree
// walls at grid boundries only

{
  // Variable declarations
        
  fixed grid_x,grid_y;   // Coordinates of x and y grid lines
  
  fixed xdist,ydist; // Distance to x and y grid lines
  fixed xmaze,ymaze;     // Map location of ray collision
  fixed distance;        // Distance to wall along ray
  //int flag;	//marks if odd or even column
  		//hold video data
 fixed column,y2,x2,xdiff,ydiff;
 fixed column_angle,radians,height,bot,top;
  fixed error,slope,x,y,xcross_x,ycross_x,xcross_y,ycross_y,xd,yd;
  u8 temp2;
  u8*  t;//temp texture*
  u16* v;//temp video*
  
fixed i,temp,total_error = 0;
  
  temp2 = 0;

  
  // Loop through all columns of pixels in viewport:
  for (column=VIEWPORT_LEFT; column<VIEWPORT_RIGHT; column++) {

    // Calculate horizontal angle of ray relative to
    //  center ray:
if(temp2)
{if(column*DivTable[20]>>16 == 0)
    {temp2 = 0;
*(u16*)(0x5000000) = 0xff;
}
else{
if(column*DivTable[20]>>16 == 0)
{ temp2 = 1;   
*(u16*)(0x5000000) = 0x0;
}}
 }    column_angle= ATAN[column];

    // Calculate angle of ray relative to maze coordinates
	
    radians=viewing_angle+column_angle;

    // Rotate endpoint of ray to viewing angle:
	if(radians > 359)
		radians -=360;
	else if(radians < 0)
		radians += 360;
	if(column_angle < 0)
		column_angle += 360;
	else if(column_angle > 360)
		column_angle -= 360;

    x2 = COS[radians]>>20;
    y2 = SIN[radians]>>20;

   // Find difference in x,y coordinates along ray:
	xdiff= x2;
    ydiff= y2;
    
    // Translate relative to viewer's position:
	x2+= xview;
    y2+= yview;

    // Initialize ray at viewer's position:

    x = xview<<16;
    y = yview<<16;

    // Get slope of ray:

    //slope = divf((ydiff),xdiff);//divf((1),xdiff)*ydiff;
	if(xdiff >0)
		slope = DivTable[xdiff]*ydiff;
    else slope = -DivTable[-xdiff]*ydiff;


    // Cast ray from grid line to grid line:

    for (;;) {

      // If ray direction positive in x, get next x grid line:

      if (xdiff>0) grid_x=((x>>16) & 0xffc0)+64;

      // If ray direction negative in x, get last x grid line:

      else grid_x=((x>>16) & 0xffc0) - 1;

      // If ray direction positive in y, get next y grid line:

      if (ydiff>0) grid_y=((y>>16) & 0xffc0) +64;

      // If ray direction negative in y, get last y grid line:

      else grid_y=((y>>16) & 0xffc0) - 1;

      // Get x,y coordinates where ray crosses x grid line:

      xcross_x=grid_x<<16;
      xcross_y=(y)+(slope*(grid_x-(x>>16)));

      // Get x,y coordinates where ray crosses y grid line:

 	
	if(ydiff > 0)
	{
		ycross_x = x + (grid_y-(y>>16))*((xdiff)*DivTable[ydiff]);
	}
	else
	{
		ycross_x = x - (grid_y-(y>>16))*((xdiff)*(DivTable[-ydiff]));
	}

  ycross_y=grid_y<<16;

      // Get distance to x grid line:

	if((x)<=xcross_x)
		xd=((xcross_x-x));
	else 
		xd=((x - xcross_x));
	
	if((y)<=xcross_y)
		yd=((xcross_y-y));
	else 
		yd=(y - xcross_y);
	
	xdist= xd+yd;

     // Get distance to y grid line:
	if((x)<=ycross_x)
		xd=((ycross_x-x));
	else 
		xd=(x - ycross_x);
	if((y)<=ycross_y)
		yd=((ycross_y-y));
	else 
		yd=((y - ycross_y));//mlkmlsdfklsjdflskdjflsdkjflp
    
	ydist= xd+yd;

      // If x grid line is closer...

      if ((xdist)<=(ydist)) {

        // Calculate maze grid coordinates of square:

        xmaze = xcross_x>>22;
        ymaze = xcross_y>>22;

        // Set x and y to point of ray intersection:

        x = xcross_x;
        y = xcross_y;

        // Is there a maze cube here? If so, stop looping:

        if (map[xmaze+(ymaze<<4)]) break;
      }
      else { // If y grid line is closer:

        // Calculate maze grid coordinates of square:

        xmaze=ycross_x>>22;
        ymaze=ycross_y>>22;

        // Set x and y to point of ray intersection:

        x=ycross_x;
        y=ycross_y;

        // Is there a maze cube here? If so, stop looping:

        if (map[xmaze+(ymaze<<4)]) break;
      }
    }

    // Get distance from viewer to intersection point:
	xd=(x>>16)-(xview);
    yd=(y>>16)-(yview);
    distance = (dist(xd*xd+yd*yd) * (COS[column_angle]>>14));

	distance = distance>>16;
	if (distance==0) distance=1;

    // Calculate visible height of wall:


    height = DivTable[distance]*(VIEWER_DISTANCE * WALL_HEIGHT)>>16;

    // Calculate bottom of wall on screen:
    bot = (height>>1) + VIEWPORT_CENTER;  

    // Calculate top of wall on screen:

    top = bot - height;

    if (height == 0) height = 1;
    
	//error = div((64<<8),height);
	error = DivTable[height]*(64<<8)>>16;
	
	if((xdist)<(ydist))
	{
		t = ((map[xmaze + (ymaze<<4)]-1)<<12) +(((y>>16) & 0x3F))+texture;
	}
	else 
	{
		t = ((map[xmaze + (ymaze<<4)]-1)<<12) +(((x>>16)& 0x3F))+texture;
	}
    // Clip wall to viewport:
	
	if (top < VIEWPORT_TOP) {
      t+= (((VIEWPORT_TOP - top)*error)>>8)<<6;
	  height -= (VIEWPORT_TOP - top);
	  ///error;   
	  top = VIEWPORT_TOP;
    }
    if ((top + height) > VIEWPORT_BOT) {
      height -= (bot - VIEWPORT_BOT);
    }

    // Find video offset of top pixel in wall column:

    v = (top * 120 + column) + Video_Buffer16;

    // Loop through all pixels in wall column:
	total_error = 0;
    
/*
	for (i=height; i; i--) {

     temp = t[(total_error>>8)<<6];
		
     *v= temp + (temp<<8);


      // Advance to next vertical pixel:

      v+=120;
	
	  // Next texture offset
	  
	  
	  total_error += error;
	 
    }//end for
*/
// /*	

	__asm
	{
		mov r1,height;  //height into r1
		mov r2,v;       //video offset into r2
		mov r3,t;       //texture offset into r3
		eor r6,r6,r6;   //total error(r6) to 0   
		mov r7,error;   //error to r7
	
loop:
	    mov r5,r6,lsr #8;      //r5 = total error>>8 (kills fraction)
		ldrb r5,[r3,r5,lsl #6]; //load t[r3+(r5<<6)]
		add r5,r5,r5,lsl #8 ;   //r5 = r5 + (r5<<8)
		strh r5,[r2],#240 ;     //*v = r5, v+=240
		add  r6,r6,r7;          //total error+=r7
		subs r1,r1,#1 ;       //height --
		bne loop;              //while height
	
	}
//*/




	}//end for(column) loop
}//end draw maze



////////////////////////////////////////curtosy of http://www.azillionmonkeys.com/qed/sqroot.html
fixed dist(fixed x)


{
    static const unsigned char sqq_table[] = {
       0,  16,  22,  27,  32,  35,  39,  42,  45,  48,  50,  53,  55,  57,
      59,  61,  64,  65,  67,  69,  71,  73,  75,  76,  78,  80,  81,  83,
      84,  86,  87,  89,  90,  91,  93,  94,  96,  97,  98,  99, 101, 102,
     103, 104, 106, 107, 108, 109, 110, 112, 113, 114, 115, 116, 117, 118,
     119, 120, 121, 122, 123, 124, 125, 126, 128, 128, 129, 130, 131, 132,
     133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 144, 145,
     146, 147, 148, 149, 150, 150, 151, 152, 153, 154, 155, 155, 156, 157,
     158, 159, 160, 160, 161, 162, 163, 163, 164, 165, 166, 167, 167, 168,
     169, 170, 170, 171, 172, 173, 173, 174, 175, 176, 176, 177, 178, 178,
     179, 180, 181, 181, 182, 183, 183, 184, 185, 185, 186, 187, 187, 188,
     189, 189, 190, 191, 192, 192, 193, 193, 194, 195, 195, 196, 197, 197,
     198, 199, 199, 200, 201, 201, 202, 203, 203, 204, 204, 205, 206, 206,
     207, 208, 208, 209, 209, 210, 211, 211, 212, 212, 213, 214, 214, 215,
     215, 216, 217, 217, 218, 218, 219, 219, 220, 221, 221, 222, 222, 223,
     224, 224, 225, 225, 226, 226, 227, 227, 228, 229, 229, 230, 230, 231,
     231, 232, 232, 233, 234, 234, 235, 235, 236, 236, 237, 237, 238, 238,
     239, 240, 240, 241, 241, 242, 242, 243, 243, 244, 244, 245, 245, 246,
     246, 247, 247, 248, 248, 249, 249, 250, 250, 251, 251, 252, 252, 253,
     253, 254, 254, 255
    };

    fixed xn;

    if (x >= 0x10000)
        if (x >= 0x1000000)
            if (x >= 0x10000000)
                if (x >= 0x40000000) {
                    if (x >= 65535UL*65535UL)
                        return 65535;
                    xn = sqq_table[x>>24] << 8;
                } else
                    xn = sqq_table[x>>22] << 7;
            else
                if (x >= 0x4000000)
                    xn = sqq_table[x>>20] << 6;
                else
                    xn = sqq_table[x>>18] << 5;
        else {
            if (x >= 0x100000)
                if (x >= 0x400000)
                    xn = sqq_table[x>>16] << 4;
                else
                    xn = sqq_table[x>>14] << 3;
            else
                if (x >= 0x40000)
                    xn = sqq_table[x>>12] << 2;
                else
                    xn = sqq_table[x>>10] << 1;

            goto nr1;
        }
    else
        if (x >= 0x100) {
            if (x >= 0x1000)
                if (x >= 0x4000)
                    xn = (sqq_table[x>>8] >> 0) + 1;
                else
                    xn = (sqq_table[x>>6] >> 1) + 1;
            else
                if (x >= 0x400)
                    xn = (sqq_table[x>>4] >> 2) + 1;
                else
                    xn = (sqq_table[x>>2] >> 3) + 1;

            goto adj;
        } else
            return sqq_table[x] >> 4;

 //   xn = (xn + 1 + div(x , xn)) >>1;
	xn = (xn + 1 + (DivTable[xn]*x>>16)) >>1;
nr1:
    //xn = (xn + 1 + div(x , xn)) >>1;
	xn = (xn + 1 + (DivTable[xn]*x>>16)) >>1;
adj:

    if (xn * xn > x)
       xn--;

    return xn;
}
