#ifndef MAZE_H
#define MAZE_H
#ifndef GBA_HEADER
#include "gba.h"
#endif


#ifndef FIXED_H
#include "fixed.h"
#endif

extern u16*Video_Buffer16;
extern fixed SIN[];
extern fixed COS[];
extern int ATAN[];
extern char map[16*16];

#define WALL_HEIGHT 64           // Height of wall in pixels
#define VIEWER_DISTANCE 128      // Viewer distance from screen
#define VIEWPORT_LEFT 0         // Dimensions of viewport
#define VIEWPORT_RIGHT 120
#define VIEWPORT_TOP 0
#define VIEWPORT_BOT 160
#define VIEWPORT_HEIGHT 160   
#define VIEWPORT_CENTER 80

#endif
